module Gosns
  require 'nokogiri'
  require 'open-uri'
  require 'json'
  require 'oauth2'
  module Helper
    class << self
      def json(url)
        JSON.parse(open(url).read)
      end

      def at_css(url, css)
        doc(url).css(css).first.text
      end

      def at_xpath(url, css)
        doc(url).css(css).text
      end

      def parse_int(str)
        str.gsub(',', '').to_i
      end

      def doc(url)
        Nokogiri::HTML(open(url, 'User-Agent' => 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/46.0.2490.86 Safari/537.36'))
      end

      def description(url)
        doc(url).css("meta[name='description']").first
      end
    end
  end

  class Sns
    attr_accessor :account
    def initialize(account)
      self.account = account
    end
  end

  require 'provider/facebook'
  require 'provider/twitter'
  require 'provider/linkedin'
  require 'provider/googleplus'
  require 'provider/pinterest'
end
