module Gosns
  class Googleplus < Sns
    class << self
      attr_accessor :redirect_uri, :key, :secret
      def oauth_authorize_url(options={})
        oauth_client.auth_code.authorize_url(
          redirect_uri: redirect_uri,
          state: options[:state],
          access_type: 'offline',
          approval_prompt: 'force',
          scope: 'https://www.googleapis.com/auth/userinfo.profile https://www.googleapis.com/auth/plus.login'
        )
      end
      def oauth_client
        option = {
          site: 'https://accounts.google.com',
          authorize_url: "/o/oauth2/auth",
          token_url: "https://www.googleapis.com/oauth2/v3/token"
        }
        OAuth2::Client.new(key, secret, option)
      end

      def token(code)
        oauth_client.auth_code.get_token(code, redirect_uri: redirect_uri)
      end
    end
    def followers
      Helper::parse_int Helper::at_css("https://plus.google.com/+#{account}", ".BOfSxb")
    end
  end
end
