module Gosns
  class Linkedin < Sns
    class << self
      attr_accessor :redirect_uri, :key, :secret
      def oauth_authorize_url(options={})
        oauth_client.auth_code.authorize_url(
          redirect_uri: redirect_uri,
          state: options[:state],
        )
      end
      def oauth_client
        option = {
          site: 'https://www.linkedin.com',
          authorize_url: "/uas/oauth2/authorization",
          token_url: "/uas/oauth2/accessToken"
        }
        OAuth2::Client.new(key, secret, option)
      end

      def get_token(code)
        oauth_client.auth_code.get_token(code, redirect_uri: redirect_uri).token
      end
    end

    def followers
      Helper::parse_int Helper::at_css("https://www.linkedin.com/company/#{account}", '.followers-count')
    end
  end
end
